close all
clear all
L            = 20; % Ordre du filtre
DownSampling = 6;  % Facteur de sous-échantillonnage

n       = 14;         % nombre de bits du quantificateur -ADC
Bw      = 4.16e3;     % Bande du signal
Fs      = 50e3;       % Fréquence d'échantillonnage
OSR     = Fs/(2*Bw);  % Rapport de sur-échantillonnage
Ts      = 1/Fs;       % Période   d'échantillonnage
PE      = 4;          % Pleine échelle du CAN
Vref    = PE/2;
N       = 2^16;                 % Nombre de points du signal d'entrée

fin_or  = 3.1e3;                % Fréquence du signal d'entrée
Bin_in  = round(fin_or/Fs*N);   % Détermination du Bin d'entrée
fin     = Bin_in*Fs/N;          % Fréquence ajustée pour qu'elle soit dans un bin d'entrée

f1_or   = 16e3;                 % Fréquence du premier interféreur
Bin1    = round(f1_or/Fs*N);    % Détermination du Bin du premier interféreur
f1      = Bin1*Fs/N;            % Fréquence ajustée pour qu'elle soit dans un bin

f2_or   = 22e3;                 % Fréquence du 2eme interféreur
Bin2    = round(f2_or/Fs*N);    % Détermination du 2eme interféreur
f2      = Bin2*Fs/N;            % Fréquence ajustée pour qu'elle soit dans un bin d'entrée


t       = 0:Ts:(N-1)*Ts;    % Vecteur Temps 
f       = 0:Fs/N:Fs/2-Fs/N; % Vecteur fréquence 

f_dec   = 0:Fs/N:Bw-Fs/N;   % Vecteur fréquence après décimation

Amplitude   = 5e-3;
Ap          = 0.01;

Bw_cut      = Fs/DownSampling/2*1.1;

SNDR_BW               = 0;
SNDR_Nyquist          = 0;
SNDR_dec              = 0;
spectre_moy           = 0;
spectre_moy_filter    = 0;
spectre_moy_dec       = 0;

% hn_freq   = [zeros(1,(L-ceil(L/6))/2),ones(1,ceil(L/6)),zeros(1,(L-ceil(L/6))/2)];
hn_freq   = [ones(1,(ceil(Bw_cut/Fs*L))),zeros(1,L-2*ceil(Bw_cut/Fs*L)),ones(1,(ceil(Bw_cut/Fs*L)))];
hn        = (ifft(hn_freq));
hn        = [(hn(floor(L/2)+1:end)),(hn(1:floor(L/2)))];
hn        = real(hn).*hanning(length(hn))';



for i = 1:10 %Moyennage sur 10 itéartions avec une phase aléatoire
    x = Amplitude*sin(2*pi*fin*t+rand()*180)+Ap*sin(2*pi*f1*t+rand()*180)+Ap*sin(2*pi*f2*t+rand()*180); %signal d'entrée
   
    D             = floor((x+Vref)*2^(n-1)/Vref);       %signal de sortie numerique -Digital Output Signal analog
    D(D<0)        = 0;      % Clipping
    D(D>2^n-1)    = 2^n-1;  % Clipping
    y             = (D-2^(n-1))/2^(n-1)*Vref+Vref/2^n;  %signal de sortie analogique equivalent -Equivalent Output Signal analog

    y_filter    = filter(hn,1,y);
    y_dec       = y_filter(1:DownSampling:N-DownSampling);
    
    
    spectre_y           = plot_spectrum(y,1,Fs,0);   %Calcul du spectre-Spectrum computation
    spectre_moy         = spectre_moy+spectre_y;
  

    spectre_y_filter    = plot_spectrum(y_filter,1,Fs/DownSampling,0); %Calcul du spectre-Spectrum computation
    spectre_moy_filter  = spectre_moy_filter+spectre_y_filter;
 

    spectre_y_dec       = plot_spectrum(y_dec,1,Fs/DownSampling,0); %Calcul du spectre-Spectrum computation
    spectre_moy_dec     = spectre_moy_dec+spectre_y_dec;
 
   
    
    SNDR_BW         = SNDR_BW+perf_estim(y,1,Bin_in,5,OSR);
    SNDR_Nyquist    = SNDR_Nyquist+perf_estim(y,1,Bin_in,5,1);
    SNDR_dec        = SNDR_dec+perf_estim(y_dec,1,Bin_in,5,1);
    
end




SNDR_BW               = SNDR_BW/i;
SNDR_Nyquist          = SNDR_Nyquist/i;
SNDR_dec              = SNDR_dec/i;

spectre_moy           = spectre_moy/i;
spectre_moy_filter    = spectre_moy_filter/i;
spectre_moy_dec       = spectre_moy_dec/i;










figure(2)
plot(f,10*log10(spectre_moy(1:N/2)),'linewidth',2);
set(gca, 'fontsize', 20)
title('spectre de la sortie du CAN')
xlabel('frequence(Hz)')
ylabel('PSD(dB/bin)')

figure(3)
plot(f,10*log10(spectre_moy_filter(1:N/2)));
set(gca, 'fontsize', 20)
title('spectre de la sortie filtree')
xlabel('frequence(Hz)')
ylabel('PSD(dB/bin)')
saveas(gcf, "Spectre-sortiefil.png");




figure(4)
plot(f_dec,10*log10(spectre_moy_dec(1:floor(N*Bw/Fs))),'linewidth',2);
set(gca, 'fontsize', 20)
title('spectre de la sortie  decimee')
xlabel('frequence(Hz)')
ylabel('PSD(dB/bin)')
saveas(gcf, "Spectre-sortiedec.png");




figure(5)
[hm,wr]=freqz(hn,1,N/2); %Calculating the frequency response of the filter
plot(wr/2/pi*Fs,20*log10(abs(hm)),'linewidth',2)
set(gca, 'fontsize', 20)
title('Reponse frequentielle')
xlabel('frequence(Hz)')
ylabel('Gain(dB)')

figure(6)
plot(f_dec,20*log10(abs(hm(1:floor(N*Bw/Fs)))),'linewidth',2)
set(gca, 'fontsize', 20)
title('Reponse frequentielle-zoom bande passante')
xlabel('frequence(Hz)')
ylabel('Gain(dB)')


%
disp(['Le SNDR dans la bande Nyquist (0 à fs/2)= ',num2str(SNDR_Nyquist),'dB'])
disp(['Le SNDR dans la bande utile (0 à ' num2str(Bw/1e3) ' kHz)= ',num2str(SNDR_BW),'dB'])
disp(['Le SNDR dans la bande utile (0 à ' num2str(Bw/1e3) ' kHz) après  décimation= ',num2str(SNDR_dec),'dB'])

%
%



























